\documentclass[11pt,a4paper]{article}

\usepackage{fullpage, amssymb, amsthm, enumerate, amsmath, pictexwd, mathrsfs, ../yomcat, ../diagrams}

%\pagestyle{empty}

\setlength{\arraycolsep}{2pt}
\setlength{\parskip}{1ex}
\setlength{\parindent}{0pt}

\newtheorem{prop}{Proposition}
\newtheorem{lemma}[prop]{Lemma}
\newtheorem{thm}[prop]{Theorem}
\newtheorem{cor}[prop]{Corollary}

\begin{document}

\part*{Gr\"obner Bases and Codes}

\section*{Cyclic Codes}
The \mbf{weight} of a vector \mbf{v} is $|\set{i|v_i \neq 0}|$. This is denoted $w(\mbf{v})$.

The \mbf{Hamming distance} of two vectors, \mbf{x} and \mbf{y}, of $GF(q)^n$ is $|\set{i|x_i \neq y_i}|$. This is denoted $d(\mbf{x}, \mbf{y})$.

The \mbf{distance} of a code $C$, normally denoted $d$, is $\displaystyle\inf_{\mbf{x},\mbf{y} \in C,\ \mbf{x} \neq \mbf{y}}\set{d(\mbf{x},\mbf{y})}$.

A \mbf{linear code} is a code where the set of codewords, $C$, forms a vector subspace of $GF(q)^n$, with dimension k. If such a code has distance $d$, it is called a $[n,k,d]$-code. A $[n,k,d]$-code has $q^k$ codewords. The distance of a linear code is $\displaystyle\inf_{\mbf{w}\in C\sm\set{0}}\set{d(\mbf{w},\mbf{0})} = \displaystyle\inf_{\mbf{w}\in C\sm\set{0}}\set{w(\mbf{w})}$.

We can consider a linear code as a function $\lambda: GF(q)^k \rTo GF(q)^n$ with image $C$. An efficient way to calculate $\lambda(\mbf{w})$ is $\mbf{w}G$, for some matrix $G$. This matrix is called a \mbf{generator matrix} for the code.

The subspace may also be described as the set of solutions of a system of $n-k$ independent linear equations in $n$ variables. The matrix of coefficients of such a system is called a \mbf{parity check matrix} for the code.

With a cyclic code, there is an isomorphism between codewords and polynomials
$$(a_0,\vect{a}{n-1}) \longleftrightarrow a_0 + a_1x + \cdots + a_{n-1}x^{n-1}$$
Then the cyclic shift of $(a_0,\vect{a}{n-1})$ to $(a_{n-1},a_0,\vect{a}{n-2})$ is the same as multiplying $a_0 + a_1x + \cdots + a_{n-1}x^{n-1}$ by $x$, and then taking the remainder on division by $x^n - 1$. Thus, we only need to consider polynomials of the ring $R = GF(q)[x]/\ideal{x^n - 1}$.

\begin{prop}
Let $R = GF(q)[x]/\ideal{x^n - 1}$. A subspace $C \subset R$ is a cyclic code if and only if $C$ is an ideal of $R$.
\end{prop}

\begin{proof}
Suppose that $C$ is a cyclic code. As it is linear, it is closed under addition, and constant multiplication. Now let $w(x) \in C$ and $f(x) = a_0 + a_1x + \cdots + a_{n-1}x^{n-1} \in R$. Then \begin{align*}
	w(x)f(x) &= w(x)(a_0 + a_1x + \cdots + a_{n-1}x^{n-1}) \\
	&= a_0w(x) + a_1w(x)x + \cdots + a_{n-1}w(x)x^{n-1}
\end{align*}
Each $a_iw(x)$ is in $C$, and then each element is multiplied by $x$ a number of times. As $C$ is cyclic, it is closed under multiplication by $x$, and so each summand is in $C$. Hence $w(x)f(x) \in C$, and $C$ is an ideal. \\
Conversely, assume that $C$ is an ideal. If $f(x)$ is a scalar, then the ideal conditions imply that $C$ is linear. $x \in R$, so $xw(x) \in C$ for all $w(x) \in C$, and so $C$ is cyclic.
\end{proof}

\begin{prop}
$R$ is a principal ideal domain. That is, every ideal is generated by a single polynomial, $g$. Moreover, $g$ is a divisor of $x^n-1$ in $GF(q)[x]$.
\end{prop}

\begin{proof}
For the first statement, see Theorem 4.3, course notes. We can assume that $g$ is the minimal such polynomial that generates the ideal $I$. Then, by the division algorithm, $x^n - 1 = q(x)g(x) + r(x)$, where $\textrm{deg}(r) < \textrm{deg}(g)$. But then $r(x) \equiv -q(x)g(x)\ \textrm{mod}(x^n -1)$, and so $r(x) \in \ideal{g(x)}$. By the minimality of $g(x)$, $r(x)$ must be 0, and so $x^n -1 = q(x)g(x)$.
\end{proof}

The polynomial $g$ in Proposition 2 is called a \mbf{generator polynomial} for the cyclic code.

\section*{The Singleton Bound}

\begin{thm}[Singleton bound]
A code $C$ of length $n$ with distance $d$ over an alphabet of size $q$ can have at most $q^{n-d+1}$ codewords. \pend
\end{thm}

Any code that meets Singleton bound with equality is called a \textbf{maximum distance seprable}, or \textbf{MDS code}. 

Given a code $C$ with $q^k$ codewords over an alphabet of size $q$, a set of $k$ coordinates is called an \mbf{information set} of $C$ if the codewords run through all $q^k$ possible $k$-tuples in that set of coordinates. That is, if there is a unique codeword associated with every possible set of symbol values in that set of coordinates. In other words, we may freely specify the symbols in these coordinates, and then the remainder of the codeword is uniquely specified.

\begin{cor}
A linear $[n,k,d]$-code over $GF(q)$ has $k \leq n - d + 1$. Equality holds if and only if every set of $k$ coordinates is an information set of the code. \pend
\end{cor}

\section*{Reed-Solomon Codes}
Choose a finite field $GF(q)$ and a primitive element of $GF(q)$, $\alpha$. Fix $k < q$, and let $L_{k-1} = \set{\sum_{i=0}^{k-1} a_it^i\ |\ a_i \in GF(q)}$ be the vectorspace of polynomials of degree at most $k-1$ in $GF(q)[t]$. To create codewords (in $GF(q)^{q-1}$), evaluate polynomials in $L_{k-1}$ at the $q-1$ non-zero elements of $GF(q)$. Hence
$$C = \set{(f(1), f(\alpha), f(\alpha^2), \dots, f(\alpha^{q-2})) \in GF(q)^{q-1}\ |\ f \in L_{k-1}}$$
is the set of codewords of a code. This code is called a \mbf{Reed-Solomon} code, denoted by $RS(k,q)$. Another way to look at Reed-Solomon codes is as a mapping, $f(z) \mapsto \set{f(\alpha^i)\ |\ 0 \leq i \leq q-2} \cup \set{f(0)}$, where $f(z)$ is one of the $q^k$ polynomials over $GF(q)$ of degree less than $k$.

\begin{thm}
$RS(k,q)$ is a linear $[n = q,k,d = n-k+1]$ MDS code over $GF(q)$.
\end{thm}

\begin{proof}
The code is linear because the sum of the codewords corresponding to two polynomials $f(z)$ and $f'(z)$ is the codeword corresponding to the polynomial $f(z) + f'(z)$, and the multiple of the codeword corresponding to $f(z)$ by $\varpi \in GF(q)$ is the codeword corresponding to the polynomial $\varpi f(z)$. \\
A codeword has a 0 in the coordinate corresponding to $\alpha^i$ if and only if $f(\alpha^i) = 0$. That is, if and only if $\alpha^i$ is a root of the equation $f(z) = 0$. By the fundamental theorem of algebra, if $f(z) \neq 0$, then since $\deg(f(z)) \leq k -1$, this equation can have at most $k-1$ roots in $GF(q)$. Therefore a nonzero codeword can have at most $k-1$ symbols, so its weight is at least $n - k + 1$. Since the code is linear, this implies that its distance is at least $n - k + 1$. But by the Singleton bound, the distance is at most $n - k + 1$. Therefore $d = n - k + 1$, and $RS(k,q)$ is a linear MDS code.
\end{proof}

To obtain a generator matrix for a Reed-Solomon code, take a basis of $L_{k-1}$ and evaluate to form the corresponding codewords. The simplest basis is the monomial basis, \set{1, t, \dots, t^{k-1}}. For example, consider $RS(4,9)$. Using the monomial basis \set{1,t,t^2,t^3} for $L_4$, the generator matrix for $RS(4,9)$ is
$$\begin{bmatrix}
1 & 1 & 1 & 1 & 1 & 1 & 1 & 1 \\
1 & \alpha & \alpha^2 & \alpha^3 & \alpha^4 & \alpha^5 & \alpha^6 & \alpha^7 \\
1 & \alpha^2 & \alpha^4 & \alpha^6 & 1 & \alpha^2 & \alpha ^4 & \alpha^6 \\
1 & \alpha^3 & \alpha^6 & \alpha & \alpha^4 & \alpha^7 & \alpha^2 & \alpha^5
\end{bmatrix}$$

\begin{prop}
Let $RS(k,q)$ have distance $d = q - k$. Then the generator polynomial for $RS(k,q)$ has the form
$$g = (x - \alpha)\cdots(x - \alpha^{d-1})$$ \pend
\end{prop}

For example, the generator polynomial of $RS(4,9)$ is $(x - \alpha)(x - \alpha^2)(x - \alpha^3)(x - \alpha^4)$.


\section*{Multivariate polynomials}
Let $R$ be a quotient ring of $GF(q)[\vect{x}{m}]$ of the form $R = GF(q)[\vect{x}{m}]/\ideal{x_1^{n_1} - 1, \dots, x_m^{n_m} - 1}$, for some $n_i \in \mbbN$. Any ideal $I$ of $R$ will be a linear code closed under multiplication by elements of $R$. We call any code obtained in this way a \mbf{m-dimensional cyclic code}.

Note that $\mbc{G} = \set{x_1^{n_1} - 1, \dots, x_m^{n_m} - 1}$ is a Gr\"obner basis for \ideal{\mbc{G}}, with respect to all term orders. Therefore standard representations for elements of $R$ can be computed by applying the division algorithm in $GF(q)[\vect{x}{m}]$ and computing remainders with respect to \mbc{G}. In this way, we obtain as representations of elements of $R$ all polynomials whose degree in $x_i$ is strictly less than $n_i$, for each $i$.

To define a $m$-dimensional cyclic code, it suffices to give a set of generators \set{\vect{f}{s}} for the ideal, $I$, of $R$. The corresponding ideal of $GF(q)[\vect{x}{m}]$ is $J = \ideal{\vect{f}{s}} + \ideal{x_1^{n_1} - 1, \dots, x_m^{n_m} - 1}$. Pick a term order on $GF(q)[\vect{x}{m}]$, and construct a Gr\"obner basis, $G = \set{\vect{g}{t}}$ for $J$ with respect to this term order. Now we have everything we need to determine whether a given element of $R$ is in $I$.

\begin{lemma}
A polynomial $h(\vect{x}{m})$ represents an element of $I$ in $R$ if and only if its remainder on division by $G$ is zero. \pend
\end{lemma}

One of the advantages of $m$-dimensional cyclic codes over generic linear codes is that their extra structure allows for a very compact representation of the encoding function. We only need to know a reduced Gr\"obner basis for $J$ to perform encoding. Typically, a Gr\"obner basis will have fewer elements than a vectorspace basis for $I$, meaning that less information needs to be stored.

Monomials that are in \ideal{\lt(J)} are known as \mbf{nonstandard monomials} for $J$. Monomials that are not in \ideal{\lt(J)} are known as \mbf{standard monomials} for $J$.

During a systematic encoding, the \mbf{information positions} of a codeword refer to the $k$ positions in the codeword that duplicate the components of the element of $GF(q)^k$ being encoded. These correspond to a certain subset of the coefficients in a polynomial representative for an element of $R$. Similarly, the parity check positions are the complementary collection of coefficients.

\begin{thm}
Let $R = GF(q)[\vect{x}{m}]/\ideal{x_1^{n_1} - 1, \dots, x_m^{n_m} - 1}$, and let $I \subset R$ be a $m$-dimensional cyclic code. Let $G$ be a Gr\"obner basis for the corresponding ideal $J$ of $GF(q)[\vect{x}{m}]$, with respect to some term order. Then there is a systematic encoding function for $I$ constructed as follows:
\begin{enumerate}
	\item[\textup{a.}] The information positions are the coefficients of the nonstandard monomials for $J$ in which each $x_i$ appears to a power strictly less than $n_i$.
	\item[\textup{b.}] The parity check positions are the coefficients of the standard monomials for $J$.
	\item[\textup{c.}] The following algorithm gives a systematic encoder, $E$, for $I$:
		\begin{description}
			\item[Input:] \textup{$G$ -- the Gr\"obner basis for $J$;} \\
				\textup{$w$ -- a linear combination of nonstandard monomials for $J$.}
			\item[Algorithm:] \textup{$w' :=$ remainder of $w$ after division by $G$.} \\
				$E(w) := w - w'$.
			\item[Output:] $E(w) \in I$
		\end{description}
\end{enumerate}
\end{thm}
\begin{proof}
The dimension of $R/I$ as a vectorspace over $GF(q)$ is equal to the number of standard monomials for $J$ since $R/I \cong GF(q)[\vect{x}{m}]/J$. The dimension of $I$ as a vectorspace over $GF(q)$ is equal to the difference dim($R$) $-$ dim($R/I$). But this is the same as the number of nonstandard monomials for $J$, in which each $x_i$ appears to a power at most $n_i - 1$. Hence the span of those monomials is a subspace of $R$ with the same dimension as $I$. Let $w$ be a linear combination of only these nonstandard monomials. By the properties of the division algorithm, $w'$ is a linear combination of only standard monomials, so the symbols from $w$ are not changed in the process of computing $E(w)$. By Lemma 5, the difference $w - w'$ is an element of the ideal $I$, so it represents a codeword. Hence $E$ is a systematic encoding function for $I$.
\end{proof}
\end{document}